"
 COPYRIGHT (c) 1996 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"



"{ Package: 'stx:libbasic3' }"

NonVersioningSourceCodeManager subclass:#HierarchicalDirectorySourceCodeManager
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-SourceCodeManagement'
!

!HierarchicalDirectorySourceCodeManager class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


!

documentation
"
    WARNING:
        this class is incomplete and provided as a sceletton
        if CVS is not to be used as a SourceCodeManager.
        We highly recommend to use CVS.

    FlatDirectorySourceCodeManager accesses sourcefiles from a
    'source' directory, which has a directory structure as delivered. 
    I.e. the libbasic-package classes are found under 'libbasic'.

    This one is not normally used with ST/X (you really should use
    CVS or some other version management)
    However, it shows how AbstractSourceCodeManager can be subclassed
    if private sourceCodeManagers are to be written.

    [test]
        for test/demo only, switch to a sourceCodeManager, which
        accesses all files directly from the 'source' directory:
            SourceCodeManager := HierarchicalDirectorySourceCodeManager.
            SourceCodeManager sourceDirectory:'../../..'.


    [author:]
        Claus Gittinger

    [see also:]
        CVSSourceCodeManager
"
! !

!HierarchicalDirectorySourceCodeManager class methodsFor:'source code access'!

streamForClass:aClass fileName:fileName revision:revision directory:packageDir module:moduleDir cache:cacheIt
    "extract a source file and return an open readStream on it,
     or nil if the extract failed. If revision is nil or (#newest), take
     the latest; otherwise, a specific revisions source is extracted.
     The cls argument is currently ignored, but may be used in future versions,
     to validate the correct container against the class."

    |f p revisionStringInFile info cls|

    cls := aClass.
    cls isMeta ifTrue:[
        cls := aClass soleInstance
    ].

    f := moduleDir , '/' , packageDir , '/' , fileName.
    SourceRoot isNil ifTrue:[
        f := Smalltalk getSourceFileName:f.
    ] ifFalse:[
        f := SourceRoot , '/' , f
    ].

    f notNil ifTrue:[
        (revision notNil
        and:[revision ~~ #newest]) ifTrue:[

            "/ validate - at least a bit of added secutiry

            p := PipeStream readingFrom:('ident < ' , f asString).
            p notNil ifTrue:[
                revisionStringInFile := p nextLine.
                p close.
            ].
            revisionStringInFile notNil ifTrue:[
                info := Class revisionInfoFromString:revisionStringInFile.
            ].
            info notNil ifTrue:[
                (info at:#revision) ~= revision ifTrue:[
                    ('SourceCodeManager [warning]: sourceFile for ' , cls name , ' has rev. ' , (info at:#revision) , '; expected: ' , revision) infoPrintCR.
                ].
            ] ifFalse:[
                'SourceCodeManager [warning]: cannot validate revision of class' infoPrintCR.
            ].
        ].

        ^ f asFilename readStream.
    ].

    ^ nil

    "Created: 14.2.1997 / 20:46:52 / cg"
    "Modified: 14.2.1997 / 20:52:12 / cg"
! !

!HierarchicalDirectorySourceCodeManager class methodsFor:'testing'!

isExperimental
    ^ true

    "Created: / 16-08-2006 / 11:23:47 / cg"
! !

!HierarchicalDirectorySourceCodeManager class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/HierarchicalDirectorySourceCodeManager.st,v 1.2 2006-08-16 09:26:33 cg Exp $'
! !
